# 1. Principles and practices

This week I worked on defining my final project idea and started to getting used to the documentation process.

## Research

"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."

> "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."

## Useful links

- [Jekyll](http://jekyll.org)
- [Google](http://google.com)
- [Markdown](https://en.wikipedia.org/wiki/Markdown)

## Installing MkDocs

I wanted to install MkDocs locally, so I could test the updates to my documentation immediately without uploading. MkDocs is installed with pip, a package manager that comes with Python, but only with the newer versions. I found out that I already had Python (because it is installed by default on macs) but an older version (2.7.18) and no pip to be found. I installed the latest version (3.9.10) hoping that would include pip as well. 

I had some trouble getting the new version activated; my shell kept using the old version. I wondered if I could just delete the old version, but some googling advised against it as mac os is actually using it. So I ended up with creating/updating the symlink to the newly installed python with 
```
ln -s -f /usr/local/bin/python3.9 /usr/local/bin/python 
```
This solution was confirmed to work on my os x version (Monterey) so I was reasonably sure it would not break things.

After that, still no pip, so I installed it by hand (or more precise, a script https://bootstrap.pypa.io/get-pip.py )

With pip installed and Python updated, I was now ready to install MkDocs.

Next step was to run a server in my documentation folder, so I issued a ```mkdocs serve``` command there. That gave me two error messages, one about a missing material theme:

```
Config value: 'theme'. Error: Unrecognised theme name: 'material'
```
and one about a missing plugin:
```
Config value: 'plugins'. Error: The "git-revision-date-localized"
            plugin is not installed
```
I googled these messages and found out I had to install the material theme and also the plugin with pip:
```
pip install mkdocs-material
pip install mkdocs-git-revision-date-localized-plugin
```

After that, the server started without problems. I changed the mkdocs.yml file to test my new setup. Hot reloads, sweet :-)

## Code Example

Use the three backticks to separate code.

```
// the setup function runs once when you press reset or power the board
void setup() {
  // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED_BUILTIN, OUTPUT);
}

// the loop function runs over and over again forever
void loop() {
  digitalWrite(LED_BUILTIN, HIGH);   // turn the LED on (HIGH is the voltage level)
  delay(1000);                       // wait for a second
  digitalWrite(LED_BUILTIN, LOW);    // turn the LED off by making the voltage LOW
  delay(1000);                       // wait for a second
}
```

## Gallery

![](../images/sample-photo.jpg)

## Video

### From Vimeo

<iframe src="https://player.vimeo.com/video/10048961" width="640" height="480" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>
<p><a href="https://vimeo.com/10048961">Sound Waves</a> from <a href="https://vimeo.com/radarboy">George Gally (Radarboy)</a> on <a href="https://vimeo.com">Vimeo</a>.</p>

### From Youtube

<iframe width="560" height="315" src="https://www.youtube.com/embed/jjNgJFemlC4" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>

## 3D Models

<div class="sketchfab-embed-wrapper"><iframe width="640" height="480" src="https://sketchfab.com/models/658c8f8a2f3042c3ad7bdedd83f1c915/embed" frameborder="0" allow="autoplay; fullscreen; vr" mozallowfullscreen="true" webkitallowfullscreen="true"></iframe>

<p style="font-size: 13px; font-weight: normal; margin: 5px; color: #4A4A4A;">
    <a href="https://sketchfab.com/models/658c8f8a2f3042c3ad7bdedd83f1c915?utm_medium=embed&utm_source=website&utm_campaign=share-popup" target="_blank" style="font-weight: bold; color: #1CAAD9;">Dita&#39;s Gown</a>
    by <a href="https://sketchfab.com/francisbitontistudio?utm_medium=embed&utm_source=website&utm_campaign=share-popup" target="_blank" style="font-weight: bold; color: #1CAAD9;">Francis Bitonti Studio</a>
    on <a href="https://sketchfab.com?utm_medium=embed&utm_source=website&utm_campaign=share-popup" target="_blank" style="font-weight: bold; color: #1CAAD9;">Sketchfab</a>
</p>
</div>


## Use HTML

You may also embed HTML in your markdown files

<hr />


Try having a seperator line


<hr />

<table border="1">
	<thead>
		<tr>
			<th>ID</th>
			<th>First Name</th>
			<th>Last Name</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>235312</td>
			<td>John</td>
			<td>Doe</td>
		</tr>
		<tr>
			<td>453123</td>
			<td>Mark</td>
			<td>Jones</td>
		</tr>
		<tr>
			<td>998332</td>
			<td>Jonathan</td>
			<td>Smith</td>
		</tr>
		<tr>
			<td>345612</td>
			<td>Andrew</td>
			<td>McArthur</td>
		</tr>
		<tr>
			<td>453123</td>
			<td>Adam</td>
			<td>Fuller</td>
		</tr>
	</tbody>
</table>
