---
title: "Computer-Aided Design"
description:
week: "02"
layout: "article"
slug: "computer-aided-design"
categories:
tags:
date: 2022-02-02T22:45:42+01:00
image: splash.jpg
math: false
hidden: false
comments: false
draft: false
menu:
    side:
        weight: -10
        params: 
            icon: date
---

This week is about design tools. 2d, 3d, raster, vector, CAD. Tools for creating 3d printer designs, tools for creating lasercutter designs, tools for rendering beautiful artist impressions. It is tempting to think that by learning these tools I, too, will be able to draw a fully working steam engine. But I know better, because I also know how to use a knife and that does not make me a good surgeon.

## to learn / to do

Model (raster, vector, 2D, 3D, render, animate, simulate, ...) a possible final project, compress your images and videos, and post it on your class page

## looking ahead

### what I already know

#### 2D design
I know the difference between vector and raster. I have used (and edited by hand) svg files. I can tell you in my sleep what the difference is between .png, .jpg and .gif . I know about The Gimp, but it stays in the cellar. I can work with Photoshop no problem. Illustrator is a bit harder for me, because I still have trouble drawing bezier curves. 

#### 3D design
Nothing really. Apart from working a bit in Unity, but that is a whole different kind of world.

### what I want to learn:
I want to learn 3D design:
I want to understand the lingo used
(bodies, components, sketches)
I want to learn to work with Fusion 360: understand the interface, understand what I am doing and why, how to get to the different ‘views’ like design and sketch etc
I want to be able to create a basic lasercutter box design, with parameters and slots & tabs
I want to get fluent in extruding
I want to learn to render and possibly animate

## the process

### lectures
After enjoying some insightful lectures (Fusion360, FreeCAD, FreeSCAD) I kind of started to get a basic understanding about the 2d and 3d modelling process. The Fusion360 lecture went a bit over my head, but the FreeCAD lecture went better because by then I had gotten more familiar with the workflow, like selecting a plane to work in and creating a sketch, and the different concepts and tools, like using construction lines, mirrors, constraints and parametric design.

The FreeSCAD lecture helped me to get a better understanding of the details, because it felt like working ‘under de hood’ in a way that was more familiar to me as a programmer.

### 2D design programs

As I already have worked a lot with both raster (Photoshop) and vector (Illustrator) programs, I did not think of making my designs for this week in one of these programs. I did use Illustrator however in the Computer Controlled Cutting week, both for post processing the shapes that I wanted to lasercut, as well as creating a shape by myself. You can see this [here](https://fabacademy.org/2022/labs/waag/students/bente-vanbourgondien/week/computer-controlled-cutting/#postprocessing-in-illustrator)

### comparing different programs
At home, I also checked out Rhino3D and SketchUp, mostly by reading side by side comparisons to Fusion360. In the end I selected Fusion360 to start with, as it looked like the more versatile option.


### Fusion360

I did a lot of tutorials in Fusion360. See the list at the bottom of this page. I will not show all the steps I took, but here a a few things I learned in the process.

#### sweep
I created a sweep in a tutorial for a paperclip. I was much easier that I thought. It involved creating a sketch with a raw outline of a paperclip with sharp corners. Then using the fillet tool to round them. After that, I switched to the front plane and drew a small circle with its centerpoint at the far end of on of the lines. Then I quit the sketch tool and selected the Sweep tool. I selected the circle as Profile and the lines for the Path. And that was it.


{{< image src="fusion-paperclip.jpg">}}

[Autodesk Fusion 360 Tutorial Paper clip (Sweep feature)](https://www.youtube.com/watch?v=gSxSPmLU5Xg)

---

{{< note >}}
When you are done editing a Sketch and you switch to 3D view, you can stille show/hide the sketch in de browser under "Sketches"
{{< /note >}}

---

{{< note >}}
If you want to edit your sketch, you can right-click it in the Sketches menu in the Browser to select Edit Sketch
{{< /note >}}

---

{{< note >}}
Sketches and Planes go together.
A plane is the orientation where you are create the Sketch. Usually the Bottom plane is best. 
{{< /note >}}

---

{{< note >}}
Hit esc (clear all commands) to turn of any tools so that the objects are selectable. 
Without hitting esc the last command stays active and this can be confusing.
{{< /note >}}

#### constraints

A tutorial about constraints clarified a lot about why I could not move objects around. 
It also showed me how I could change dimensions later and gave me more insight in how Fusion360 thinks and works.
To get a Sketch from being blue (not fully constrained) to black (constrained) it is important that it is:
- placed
- dimensioned

{{< note >}}
Use the vertical/horizontal constraint to connect lines to a certain point. Now they are not movable anymore.
{{< /note >}}

[Learn Fusion 360 or Die Trying LESSON 3: Understanding Constraints](https://www.youtube.com/watch?v=GTlf_4A1yR0&list=PLGs0VKk2DiYx15SfBxO_VE6ELhpy0VnAw&index=3)

#### offset planes

You can also create objects over multiple planes. For this you use offset planes. I created a Whiskey bottle with this tutorial,
and used the Loft tool with a guide rail. It was a bit tricky to get the guide rail to connect to the sketchlines in the different planes, but eventually I figured it out.


{{< note >}}
Loft with rail over multiple offset planes:
Make sure the rail really touches the shapes in the offset planes. Using intersecting construction lines might help
{{< /note >}}

---

{{< image src="fusion-whiskey-bottle.jpg">}}



[How to 3D Model a Whiskey Bottle - Learn Autodesk Fusion 360 in 30 Days](https://www.youtube.com/watch?v=pqXCswoa3F4)

{{< note >}}
On saving:
Hitting save in fusion360 actually creates a new version. Saving in Fusion360 is like pushing a version to the repository.
Fusion360 auto saves every 5 minutes by default. You can change this in the settings.
{{< /note >}}

### change of plans

During the week the shape/form of my end project had changed from something vertical to something more horizontal. More like a bowl with a water vortex in it. While watching fusion360 tutorials I had this shape in mind, but when I wanted to start making it I realised I wanted to animate the vortex in a way that was not possible in fusion360. 
In Blender on the other hand, it was possible. Should have thought of that and studied that program first :-/

So I started a Blender tutorial, to see if I could get to understand the steps from the Blender 3d water vortex tutorial. I should probably first create a Fusion360 model at this point so that I have at least something to upload to my project documentation. But I really feel more like diving into Blender. Even though I know this is not a circular step at all, I decide to go along with my instinct. Let’s see where it gets me. Better be adventurous and risk to fail the circular pattern in the beginning of the course, than in the middle.

### Blender

Blender has some good video tutorials and after working my way through Fusion360 it almost felt like coming home. Most of the concepts and tools where familiair to me, probably because my little experience in Unity. Still, it took me a whole day of trying, playing and tutorialing to get to the point that I had a basic idea of the steps I needed to take.

The things I needed to learn for that were:

#### how to create a (glass) bowl 

tutorial: [Making a Glass Bowl in Blender 2.8](https://www.youtube.com/watch?v=_XTQnSXwHhM)

The tutorial I followed started with a Sphere, and deleting the top vertices. It also flattened the bottom vertices, leaving a hollow bowl shape. It then changed the material of the bowl to look like glass.

#### Mantaflow

tutorial:[An Introduction to Fluid Simulation | Blender Mantaflow Part 1](https://www.youtube.com/watch?v=gmsk_LkeGIs)

The liquid simulator consists of 3 parts:

**domain cube**
		
this is the ‘world’ where the simulation takes place. Here you can specify general settings that modify the liquid and how it is rendered

**flow objects**

a flow object generates the flow. I used an inflow object, because I thought that would come in handy when creating the movement. 

**effectors**
		
effectors are objects that can collide with the flow or guide it. I set my bowl to be an collision effector, so that the liquid would flow into it

{{< image src="collision-effector.jpg" >}}


#### circular momentum/flow

**First try: directing the Flow object**

First I tried directing the flow from the flow object horizontal so that it would collide with the inside of the bowl. I hoped it would flow naturally round in the bowl that way. That worked a bit, but the force of the collision made the liquid also splash back and so I got a kind of messy flow that collided with itself. As far as I could see there was no option to fine tune the flow so that it would collide gentler and in the right angle. After some tweaking I abandoned  this idea.

{{< image src="inflow.jpg" >}}

---

{{< image src="velocity.jpg" width="400" >}}

---
{{< image src="flow.jpg" >}}

---

**Second try:using a vortex**

tutorial:[Creating a Vortex in a Glass | Blender Mantaflow Part 11](https://www.youtube.com/watch?v=riDHU5lQM_k&list=PLbyYlLq2pvAb63HtIgG6dbeKUAZ2-Wpdq&index=11)

Next I tried to create a vortex. This seemed to work better. It involved 3 steps:
	- creating a vortex Add - Force Field - Vortex
	- moving it into a Collection: M -> new Collection
	- add it to the Liquid Domain: Section Field Weights, property Effector Collection, select created Collection

{{< image src="vortex.jpg" >}}

The vortex looked better than the horizontal flow. I played a bit around to make the liquid look more like water, but since the bowl was already a glass bowl it became hard to see. In the end I settled for a ceramic looking bowl and a blueish looking liquid. I had no time to make it look better by adding something like a surface under the bowl, or play with light, so I rendered the bowl hanging in mid air.

#### rendering the final animation

tutorial:[Blender 2.8 Tutorial: Rendering an Animation](https://www.youtube.com/watch?v=LPbUuMs2i20)

Rendering took about two hours and resulted in an image sequence of 150 pngs that I could convert into an mpeg movie with the image sequencer.

For this, I changed the output properties to
- Output: 
  - file format ffmpeg video
— Post Processing: 
  - check Image Sequencer

Don't forget to reset these to 

- Output: 
  - file format PNG
  - UNcheck Overwrite
— Post Processing: 
  - UNcheck Image Sequencer

When the render was complete I saw that I made the wrong assumption. I thought the 'flow' object was a virtual element, and that it would not be rendered visually. I was wrong. Now that I had a more detailed view, I saw it lying in the middle of the bowl.

{{< video src="first-render.mp4" type="video/mp4" preload="auto" >}}

I also saw that the vortex did not really work as I expected. It generated a kind of bump, while I thought it would be more of a flat horizontal stirring motion.

And lastly: no light! Still a lot to learn I guess.

Not what I had in mind. A rabbithole of late hour tweaking followed. I changed the flow object from 'inflow' to 'geometry' , in the assumption that I would create a body of liquid in this way. I also tweaked with the vortex settings and how the vortex reacted in the container. But there were a lot of settings for that, and I did not really know what they all meant.

{{< image src="force_liquid.jpg" width="400px" >}}

The vortex flattened a bit when I turned down its strength. Ofcourse that also resulted in a weaker movement. But it was late. I was getting tired. I initiated another render, saw that it would take almost 4 hours and went to bed. 

In the morning I was greeted by this:

{{< video src="second-render.mp4" type="video/mp4" preload="auto" >}}

Yes, I made the wrong assumption again. That soap in the middle is my flow object. 
But at least I was able to fix the lighting.

### after the global review

During the global review I was pointed out that indeed, you can keep an object from rendering in the final render. Just set its visibility in the object properties. 

My fellow student Bas pointed me to some optimisation settings in Blender so I actually had a functioning Render Preview panel(I forgot, have to ask him again) and also showed me that you do not have to render all samples if the model already looks good after the first 100 or so samples.

He also showed me how to use a light emitting material, for more natural lighting without a actual light source (sun, spot) and to add a hdr image to the background to also enhance the final render.

In that process I also found out that I had the Intel version of Blender installed, while I have a M1 processor. Downloading the Silicon version as we speak. Looking forward to blazingly fast renders.

So here is the real final render:


## looking back

- *I want to understand the lingo used (bodies, components, sketches)*
- *I want to learn to work with Fusion 360: understand the interface, understand what I am doing and why, how to get to the different ‘views’ like design and sketch etc*
- *I want to be able to create a basic lasercutter box design, with parameters and slots & tabs*
- *I want to get fluent in extruding*
- *I want to learn to render and possibly animate*


I again learned a lot this week! When looking at my goals from the beginning of the week, I would say that I was successful enough. I got to understand the lingo, figured out how sketches and bodies were connected in Fusion360 and I also got a good understanding of the interface. 

I got to understand parametric design in Fusion360 (and also in FreeCAD)

I did not create a basic lasercutter design however, because I focussed on the tasks for this week to create a (3d) model for my final project.
I did not become fluent in extruding, but I became as fluent as I hoped to be.


I did not go into the animation part in fusion360, because I needed that time to get to understand Blender.

I learned to use Blender! Compared to Fusion360, Blender works really intuitively. I enjoyed working with Blender more, it feels more free to work in it. I understand where Fusion360 is coming from though, it has a completely different background, and also a different use case. With Fusion360 you have to be specific, it is point and click and type. The whole interface radiates its history as a product design tool. Blender is much younger. 

I am happy with my decision to dive into Blender before trying to to make my model in Fusion360. Although it took me much longer that I thought, and involved more steps and lots of tutorials (listed below). And even though it did not really work out in the end.

I am happy that I was able to create a basic animation that shows what I think my final project can look like. Since the flow of the water is the important part, the animation is necessary. I will get rid of the bar of soap in the middle eventually. Or who knows, maybe there is some serendipity in there. 

In hindsight it would have been better to think of what I wanted to create first before diving into a program (Fusion360). But I will use Fusion360 anyway, so that work was not in vain.

### lessons learned

The struggle with the flow object is a lesson in learning to step back. All the time I was trying to hide the input, while in would have been better to give it a place. After all, in the real world there also would be some kind of flow or water input. For example, I could have built it through the wall or the bottom of the bowl. That way I can play and simulate with different solutions before building them.

What I also learned is that it is better to set reasonable goals. There is only so much time in a week, and part of it is also spent learning the tools at hand. It might look cool in my head, but if I am not able to make it that way in the time I have, it is better to go for a more simple but realistic solution. It's also a good idea to keep monitoring my progress during the week and adjust the goals accordingly.

But still, going in the way I did also meant I learned much more than expected.

### files
<!--
[tutorial: creating a 3d stamp (fusion360)](sources/custom-stamp-tutorial.f3d)\
[tutorial: creating a paperclip (fusion360)](sources/paperclip-tutorial.f3d)\
[tutorial: creating a whiskey bottle (fusion360)](sources/tutorial-whiskey-bottle.f3d)\
[tutorial: creating a parametric box (fusion360)](sources/parametric-tutorial.f3d)\
[waterbowl (blender)](sources/waterbowl-optimized-by-bas.blend)
-->

[here are the files for this week](https://gitlab.fabcloud.org/academany/fabacademy/2022/labs/waag/students/bente-vanbourgondien/-/tree/master/src/week_02)

## tutorials, tutorials, tutorials

[The Bézier Game](https://bezier.method.ac/)

### Fusion360
[Fusion 360 Tutorial for Absolute Beginners](https://www.youtube.com/watch?v=A5bc9c3S12g)\
[Fusion 360 Tutorial for Absolute Beginners (2020)](https://www.youtube.com/watch?v=qvrHuaHhqHI)\
[Fusion 360 Mistakes I Make Sketching (10 Things To Avoid)](https://www.youtube.com/c/TylerBeckofTECHESPRESSO)\
[Learn Fusion 360 or Die Trying LESSON 1: Introduction tutorial for Absolute Beginners](https://www.youtube.com/watch?v=y5tp4QXciK4&list=PLGs0VKk2DiYx15SfBxO_VE6ELhpy0VnAw&index=1)\
[Learn Fusion 360 or Die Trying LESSON 3: Understanding Constraints](https://www.youtube.com/watch?v=GTlf_4A1yR0&list=PLGs0VKk2DiYx15SfBxO_VE6ELhpy0VnAw&index=3)
[Learn Fusion 360 or Die Trying LESSON 5: Understanding Parametric Design and Modeling](https://www.youtube.com/watch?v=nlCxEyh11Hk&list=PLGs0VKk2DiYx15SfBxO_VE6ELhpy0VnAw&index=5)


### Blender
[Blender Fundamentals 2.8](https://www.youtube.com/playlist?list=PLa1F2ddGya_-UvuAqHAksYnB0qL9yWDO6)\
[Creating a Vortex in a Glass | Blender Mantaflow Part 11](https://www.youtube.com/watch?v=riDHU5lQM_k&list=PLbyYlLq2pvAb63HtIgG6dbeKUAZ2-Wpdq&index=11)\
[An Introduction to Fluid Simulation | Blender Mantaflow Part 1](https://www.youtube.com/watch?v=gmsk_LkeGIs)\
[the New Blender Fluid Simulator is AWESOME - MantaFlow Tutorial](https://www.youtube.com/watch?v=JYc_6fXEjw4)\
[Learn Blender's NEW Water Physics in 6 minutes! (Blender 2.9+)](https://www.youtube.com/watch?v=e3mhJXuveFo)\
[Quick Water Animation in Blender 3.0 (API methods) Easy Way](https://www.youtube.com/watch?v=6dCcwAUQGC0)\
[Making a Glass Bowl in Blender 2.8](https://www.youtube.com/watch?v=_XTQnSXwHhM)\
[Blender 2.8 Tutorial: Rendering an Animation](https://www.youtube.com/watch?v=LPbUuMs2i20)