// TIMER
#include "millisDelay.h" 
//#define DEMO_INTERVAL 3600 // 3600 * 50 cycles = 180 seconds = 3 minutes for sun up and sundown

#define DEMO_INTERVAL 7200 // 7200 * 50 cycles = 360 seconds = 6 minutes for sun up
#define LED_SAVE_INTERVAL 500

// .5 minute pause    = 15 seconds        = 2 cycles    4
// 2,5 minutes        = 150 seconds flood = 21 cycles   21
// .5 minute pause    = 30 seconds        = 4 cycles    29
// 2,5 minutes ebb    = 150 seconds       = 21 cycles   46
// .5 minute pause    = 15 seconds        = 2 cycles    50

millisDelay demoDelay;
millisDelay ledSaveDelay;

// LED

#include <tinyNeoPixel_Static.h>

#define NUMPIXELS 40 
#define BRIGHTNESS 12
#define CLOCK_LED 0 

// PUMP
#define OUT_1 2
#define OUT_2 3

// TEST

#define TEST_LED 10


bool flood = true;

bool up = true;

byte pixels[NUMPIXELS * 3];
tinyNeoPixel leds = tinyNeoPixel(NUMPIXELS, CLOCK_LED, NEO_GRB, pixels);

uint8_t colormap[50][3] = {{51,204,204},{62,204,202},{71,204,201},{80,204,199},{87,204,198},{94,204,196},{100,204,195},{106,204,193},{112,204,191},{118,204,190},{123,204,188},{128,204,186},{133,204,185},{137,204,183},{142,204,181},{146,204,180},{150,204,178},{154,204,176},{158,204,174},{162,204,172},{166,204,171},{170,204,169},{173,204,167},{177,204,165},{180,204,163},{184,204,161},{187,204,159},{191,204,157},{194,204,155},{197,204,153},{200,204,151},{203,204,149},{206,204,147},{209,204,145},{212,204,143},{215,204,141},{218,204,138},{221,204,136},{224,204,134},{226,204,131},{229,204,129},{232,204,127},{235,204,124},{237,204,122},{240,204,119},{242,204,116},{245,204,114},{248,204,111},{250,204,108},{253,204,105}};

int max_cycles = 50;
int cycles = 0;

int save_cycles = 0;
int max_save_cycles = 1000;

// end LED

void setup() {
  
    delay( 1000 ); // power-up safety delay

    // test LED
    pinMode(TEST_LED, OUTPUT);

     // clock LED
    pinMode(CLOCK_LED, OUTPUT);
    leds.begin(); // INITIALIZE NeoPixel strip object (REQUIRED)    
    leds.setBrightness(BRIGHTNESS);

    // PUMP
    pinMode(OUT_1, OUTPUT);
    pinMode(OUT_2, OUTPUT);    

    demoDelay.start(DEMO_INTERVAL);
    ledSaveDelay.start(LED_SAVE_INTERVAL);

}

// the loop function runs over and over again forever
void loop() {
    
  // test LED
  //digitalWrite(TEST_LED, HIGH);   // turn the LED on (HIGH is the voltage level)
  //leds.clear();
  
  if (demoDelay.justFinished()) {

    // handle brightness
    if (cycles < 10) {
      leds.setBrightness(BRIGHTNESS);      
    }
    if (cycles > 10 && cycles < 20) {
      leds.setBrightness(BRIGHTNESS + 1);      
    }
    if (cycles > 20 && cycles < 30) {
      leds.setBrightness(BRIGHTNESS + 2);      
    }
    if (cycles > 30 && cycles < 40) {
      leds.setBrightness(BRIGHTNESS + 3);      
    }
    if (cycles > 40 && cycles < 50) {
      leds.setBrightness(BRIGHTNESS + 4);      
    }



   
    // handle pump
    // .5 minute pause    = 15 seconds        = 2 cycles    2
    // 2,5 minutes        = 150 seconds flood = 21 cycles   23
    // .5 minute pause    = 30 seconds        = 4 cycles    27
    // 2,5 minutes ebb    = 150 seconds       = 21 cycles   48
    // .5 minute pause    = 15 seconds        = 2 cycles    2    
    if (cycles >= 0 && cycles <= 2) {
      // pause
      digitalWrite(OUT_1, LOW);
      digitalWrite(OUT_2, LOW);            
    }
    else if (cycles > 2 && cycles <= 23) {
      // up
      digitalWrite(OUT_1, HIGH);
      digitalWrite(OUT_2, LOW);        
    }
    else if (cycles > 23 && cycles <= 27) {
      // pause
      digitalWrite(OUT_1, LOW);
      digitalWrite(OUT_2, LOW);                  
    }
    else if (cycles > 27 && cycles <= 48) {
      // down
      digitalWrite(OUT_1, LOW);
      digitalWrite(OUT_2, HIGH);      
    }
    else if (cycles > 48 && cycles <= 50) {
      // pause
      digitalWrite(OUT_1, LOW);
      digitalWrite(OUT_2, LOW);                  
    }
    
    if (up) {
      cycles += 1;
      if (cycles >= max_cycles)
      {
        up = false;
        cycles = max_cycles-1 ;
      }
    }
    else {
      cycles -= 1;
      if (cycles < 0)
      {
        up = true;
        cycles = 0;
      }
    }
    
    

    demoDelay.repeat();
  }

  if (ledSaveDelay.justFinished()) {
    if (save_cycles >= max_save_cycles)
    {
      save_cycles = 0;
    }
      
    if (save_cycles%2 == 0){
      // handle color
      for(int i=0; i < NUMPIXELS; i++) { 
              
        leds.setPixelColor(i, leds.Color(colormap[ cycles ][0], colormap[ cycles ][1] - 100 , colormap[ cycles ][2] - 100));
        //leds.setPixelColor(i, leds.Color(51, 204, 204));
        leds.show(); 
      }           
    }
    else {
        leds.clear();      
    }    

    ledSaveDelay.repeat();
  }  

}
