
int long_delay = 1000; // 1000 ms = 1 sec
int short_delay = 300; // 500 ms = 0.5 sec

int pause_delay = 1000;
boolean pause = false;

int range = 250;

//#define TESTING 1

//static const unsigned int refresh_interval = 1000; // milliseconds
long button_time = 0;
long play_time = 0;

String sequence = "01010010110101010001"; // 1 - long light, 0 is short light
int simon_current = 0;
int playing_current = 0;
int listening_current = 0;

int button_state = -1;

int mode = 0; // 0 is idle, 1 is playing, 2 is listening 

char c;

void setup() {

    //pinMode(LED, OUTPUT);
    //pinMode(BUTTON, INPUT_PULLUP);
      background(0, 90, 115);
      
      noStroke();
}

void draw() {
    if (mode == 0) {
      //print("IDLE");
      // idle, wait for click
      if (button_state == 1) {
          mode = 1;
      }
    }
    else if (mode == 1) {
      //print("PLAYING");
      // playing, play the sequence up until simon current
      
      if (play_time == 0) {
        println("seq:" + playing_current);
        println("sim:" + simon_current);
        
        c = sequence.charAt(playing_current);
      }
      
     // println("c:" + c);
      if (pause) {
          if (play_time == 0) {
             fill(0, 90, 115);
             circle(50,50,100); 

            println("start pause");
            play_time = millis();
          }
          else {
            long diff = millis() - play_time;
            if (diff > pause_delay) {
                 
                 play_time = 0;
                 println("end pause");
                 pause = false;
             }         
          }
      }
      else {
        if (c == '0') {
         // show a short light
               

         if (play_time == 0) {
            println("short light");  
           play_time = millis();
           fill(0,255,0);
           circle(50,50,100);        

         }
         else {
           long diff = millis() - play_time;
           if (diff > short_delay) {
               fill(0, 90, 115);
               circle(50,50,100); 
               println("end short light");  
               play_time = 0;
           }
         }
        }
        else {
          // show a long light
          //println("long light");
  
          if (play_time == 0) {
            fill(0,255,0);
            circle(50,50,100);        
            
            println("long light ");
            play_time = millis();
          }
          else {
            long diff = millis() - play_time;
            println("\ndiff: " + diff);
            if (diff > long_delay) {
                 fill(0, 90, 115);
                 circle(50,50,100); 
                                 
                 play_time = 0;
                 println("end long light");                
             }         
          }
        }
        
        if (play_time == 0) {
          if (playing_current == simon_current) {
            // we are done, start listening
            mode = 2;
            playing_current = 0;
            listening_current = 0;
            
            // simon_current = simon_current + 1;
            println("start listening");      
            fill(0, 90, 115);
            circle(50,50,100);
          }
          else {
              playing_current = playing_current + 1;
              pause = true;
          }
        }
      }      
      
          
     
      
    }
    else if (mode == 2){
      // listening
      //print("LISTENING");
      c = sequence.charAt(listening_current);
                
      if (button_time == 0 && button_state == 0) {
          println("c:" + c);
        
          // button was pressed and no time was set yet
          fill(0,255,0);
          circle(50,50,100);
          
          button_time = millis();
          //print("\nbutton_down:" + button_down);          
      }
      else if (button_time > 0 && button_state == 1 ) {
        
          // button was released and there is a time set
          // up
          long diff = millis() - button_time;
         // print("\ndiff: " + diff);
          
          button_time = 0;
          
           fill(0, 90, 115);
          circle(50,50,100);      
          
          boolean correct = false;
          if( diff >= (long_delay - range) && diff < long_delay + range) {
            print("\nlong press");
            if (c == '1') {
              println("correct!");
              correct = true;
            }          
          }
          else if( diff >= (short_delay - range) && diff < short_delay + range) {
            print("\nshort press");
            if (c == '0') {
              println("correct!");
              correct = true;
            }
          }
          if (correct) {
            if (listening_current == simon_current) {
                // we are done, up simon and start waiting again
                mode = 0;
                
                playing_current = 0;
                listening_current = 0;
                simon_current = simon_current + 1;
                button_state = 1;
                pause = true;
                
                println("start playing");      
                fill(0, 90, 115);
                circle(50,50,100);
            }
            else {
                listening_current = listening_current + 1;
            }
         }
      }
    }
}

void mouseReleased() {
     button_state = 1;
}

void mousePressed() {
     button_state = 0;
}
