
const { SerialPort } = require('serialport')
const { ReadlineParser } = require('@serialport/parser-readline')

const WebSocket = require('ws');

const WEBSOCKET_ADDRESS = 'wss://socketsbay.com/wss/v2/2/demo/';

// Change the serial port to the port that your board is connected to
const SERIAL_PORT = '/dev/tty.usbmodem21101';

// you can probably leave these as is
const BAUD_RATE = 9600;

// SERIAL PORT 

// open the serialport
console.log("opening serial port on %s",SERIAL_PORT);

const serialPort = new SerialPort({
  path: SERIAL_PORT,
  baudRate: BAUD_RATE,
})

// error handling (no connection, no port etc)
serialPort.on("error",err => {
  console.log(err);
});

// fires when the serial port opens no problem
serialPort.on("open", data => {
    console.log("-serial port opened succesfully");
});


// this receives and displays raw data
serialPort.on("data", data => {
   //console.log(data);
});


// create a parser to parse the raw data
const parser = new ReadlineParser();
serialPort.pipe( parser );
// whenever we get data from the serial port....
parser.on("data", data => {
        // send it to the clients
        if (ws.readyState == ws.OPEN) {

          // 
          ws.send(data)        
        }
        else {
            // or pass it to the console if there is no client connected
            console.log(data);
        }

});

var ws = new WebSocket(WEBSOCKET_ADDRESS);
ws.on('open', function() {
    ws.send('something');
});
ws.on('message', function(data, flags) {
    // flags.binary will be set if a binary data is received
    // flags.masked will be set if the data was masked
});