// this example loads another cat, every time you press the button on the Hello World board.
// It uses the generic server.js from the other examples

// listen to the socket server
let socket = new WebSocket("ws://localhost:1337");

let requestSent = false;

socket.onopen = function(e) {
  console.log("[open] Connection established");
  console.log("Sending to server");
  //socket.send("hi, I am listening!");
};

// when we get a message from the server (when the button is pressed on the board)
socket.onmessage = function(event) {
   //console.log(`[message] Data received from server: ${event.data}`);

  if (event.data == 0 ) {

      if (!requestSent) {

          requestSent = true;
          // every time the button is pressed, get me a cat
          console.log("get cat")
          
          /*

          this uses
            https://api.thecatapi.com/v1/images/search

            it will give a json response like this:

            [
              {
                "breeds": [
                  
                ],
                "id": "vKcrwdUwo",
                "url": "https://cdn2.thecatapi.com/images/vKcrwdUwo.jpg",
                "width": 876,
                "height": 657
              }
            ]
          */
          // html request
          var xmlhttp = new XMLHttpRequest();

          xmlhttp.onreadystatechange = function() {
              if (this.readyState == 4 && this.status == 200) {

                  // we got json back, parse it
                  var myArr = JSON.parse(this.responseText);

                  //console.log();

                  // get the first element and take property url, use
                  // it to set the src attribute of the image in the html file
                  document.getElementById("cat-image").src = myArr[0].url;

                  requestSent = false;
              }
          };

          // do the request
          xmlhttp.open("GET",  "https://api.thecatapi.com/v1/images/search", true);
          xmlhttp.send();

      }

  }
  else {
    document.body.style.backgroundColor = 'white'
  }

};

socket.onclose = function(event) {
  if (event.wasClean) {
    console.log(`[close] Connection closed cleanly, code=${event.code} reason=${event.reason}`);
  } 
  else {
    // e.g. server process killed or network down
    // event.code is usually 1006 in this case
    console.log('[close] Connection died');
  }
};

socket.onerror = function(error) {
    console.log(`[error] ${error.message}`);
};

