// set up the ws client, connect on localhost, to the same port that is used in server.js
let socket = new WebSocket("ws://localhost:1337");

socket.onopen = function(e) {
  console.log("[open] Connection established");
  console.log("Sending to server");

  // this is how you send a message to the server (and thus to the serialport)
  // socket.send("hi, I am listening!");
};

// whenever we get a message from the server (= from the serialport)
socket.onmessage = function(event) {
   console.log(`[message] Data received from server: ${event.data}`);
  
   //console.log(document.getElementById("myshape").style.left)
   if (event.data == 1) {
    document.getElementById("myshape").style.backgroundColor = 'green'
   }
   else {
    document.getElementById("myshape").style.backgroundColor = 'red'
   }
};


socket.onclose = function(event) {
  if (event.wasClean) {
    console.log(`[close] Connection closed cleanly, code=${event.code} reason=${event.reason}`);
  } 
  else {
    // e.g. server process killed or network down
    // event.code is usually 1006 in this case
    console.log('[close] Connection died');
  }
};

socket.onerror = function(error) {
    console.log(`[error] ${error.message}`);
};